#Generating directed P4 if also no T3

def plot_header():
    print "Latex"

def plot_P4(v,str,special=[]):
    print '\\begin{tikzpicture}\\base'
    split = [0,1.7,1.7,1.7,1.7,1.7]
    for i in range(4):
        blob = v[i]
        if i in set(special):
            print '\draw (270-72-72*{}:{}) node[insep_special](y{}){};'.format(blob,split[blob],i,"{}")
        else:
            print '\draw (270-72-72*{}:{}) node[insep](y{}){};'.format(blob,split[blob],i,"{}")
        split[blob] += 0.3
    print '\\draw[full] (y0)--(y1); \\draw[full] (y1)--(y2); \\draw[full] (y2)--(y3);'
    print '\\draw (0,-3) node{'+str+'};'
    print '\\end{tikzpicture}'

def contains_a_to_b(v,a,b):
    for i in range(3):
        if v[i] == a and v[i+1] == b:
            return True
    return False

def find_ab(v,a,b):
    for i in range(3):
        if v[i] == a and v[i+1] == b:
            return [i,i+1]
    return None    

def contains_a_nonedge_b(v,a,b):
    if v[0] == a and v[2] == b:
            return True
    if v[0] == a and v[3] == b:
            return True
    if v[1] == a and v[3] == b:
            return True
    return False

def find_ab_nonedge(v,a,b):
    if v[0] == a and v[2] == b:
            return [0,2]
    if v[0] == a and v[3] == b:
            return [0,3]
    if v[1] == a and v[3] == b:
            return [1,3]
    return None   


def is_edge(a,b):
    if a == 0 or b == 0 or (a+1 == b) or (a == b) or (a == 5 and b == 1):
        return True
    return False

def is_non_edge(a,b):
    if a == 0 or b == 0:
        return True
    if a+1 == b:
        return False
    if (a == 5) and (b == 1):
        return False
    if b+1 == a:
        return False
    if (b == 5) and (a == 1):
        return False
    return True

def is_funky_type_1(a,b):
    if a == 0 or b == 0:
        return False
    if a == b+1 or (a == 1 and b == 5):
        return True
    return False

def is_funky_type_2(a,b):
    if a == 0 or b == 0:
        return False
    if a == b+2 or (a == 1 and b == 4) or (a == 2 and b == 5):
        return True
    return False


def is_funky_type_4(a,b):
    if a == 0 or b == 0:
        return False
    funky_4 = set([12, 15, 23, 21, 34, 32, 43, 45, 51, 54])
    if (a*10+b) in funky_4:
        return True
    return False


def test_v_funky_a_to_b(v, from_a, to_b, use_df=False, skip_type1=False, skip_type2=False, skip_type4=False):
    if not contains_a_to_b(v,from_a, to_b):
        return None
    
    for [x,y] in [[0,1], [1,2], [2,3]]:
       if skip_type1 and is_funky_type_1(v[x],v[y]):
           return None
       if skip_type2 and is_funky_type_2(v[x],v[y]):
           return None

    for [x,y] in [[0,2], [0,3], [1,3]]:
       if skip_type4 and is_funky_type_4(v[x],v[y]):
           return None


    
    [a,b] = find_ab(v, from_a, to_b)
            
    # Path is a--b--x--y 
    if a == 0:
        [x,y] = [2,3] # here [a,b] = [0,1]
        if (not is_edge(v[2],v[3])) or (v[2] == v[3]):
            return "f"
        #print v
        str_x = "x[{}]".format(v[2])
        str_y = "x[{}]".format(v[3])
        if use_df:
            if v[x] == v[a]:
               str_x = "danon"
            if v[x] == v[b]:
               str_x = "dbout"
            if v[y] == v[a]:
               str_y = "danon"
            if v[y] == v[b]:
               str_y = "dbnon"
        if v[b] == v[x]:
            str_x = "dfb"       
        if not is_non_edge(v[a],v[2]):
            str_x = "dfa[{}]".format(v[2])
        if not is_non_edge(v[a],v[3]):
            str_y = "dfa[{}]".format(v[3])
        if not is_edge(v[b],v[2]):
            str_x = "dfb[{}]".format(v[2])
        if not is_non_edge(v[b],v[3]):
            str_y = "dfb[{}]".format(v[3])
           
    # path x--a--b--y
    if a == 1:
        [x,y] = [0,3] # here [a,b] = [1,2]
        if (not is_non_edge(v[0],v[3])) or (v[x] == v[y]):
            return "f"
        #print v
        str_x = "x[{}]".format(v[0])
        str_y = "x[{}]".format(v[3])
        if use_df:
            if v[x] == v[a]:
               str_x = "dain"
            if v[x] == v[b]:
               str_x = "dbnon"
            if v[y] == v[a]:
               str_y = "danon"
            if v[y] == v[b]:
               str_y = "dbout"
        if v[b] == v[y]:
            str_y = "dfb"  
        if v[a] == v[x]:
            str_x = "dfa"                           
        if not is_edge(v[0],v[1]):
            str_x = "dfa[{}]".format(v[0])
        if not is_non_edge(v[1],v[3]):
            str_y = "dfa[{}]".format(v[3])
        if not is_non_edge(v[0],v[2]):
            str_x = "dfb[{}]".format(v[0])
        if not is_edge(v[2],v[3]):
            str_y = "dfb[{}]".format(v[3])

    # Path is x--y--a--b
    if a == 2:
        [x,y] = [0,1] # here [a,b] = [2,3]
        if (not is_edge(v[0],v[1])) or (v[x] == v[y]):
            return "f"
        #print v
        str_x = "x[{}]".format(v[0])
        str_y = "x[{}]".format(v[1])
        if use_df:
            if v[x] == v[a]:
               str_x = "danon"
            if v[x] == v[b]:
               str_x = "dbnon"
            if v[y] == v[a]:
               str_y = "dain"
            if v[y] == v[b]:
               str_y = "dbnon" 
        if v[a] == v[y]:
            str_y = "dfa"                        
        if not is_non_edge(v[x],v[a]):
            str_x = "dfa[{}]".format(v[x])
        if not is_edge(v[y],v[a]):
            str_y = "dfa[{}]".format(v[y])
        if not is_non_edge(v[b],v[x]):
            str_x = "dfb[{}]".format(v[x])
        if not is_non_edge(v[b],v[y]):
            str_y = "dfb[{}]".format(v[y])    
    #print "{} {}*{}".format(v,str_x,str_y)     
    #print "{}*{}".format(str_x,str_y)
    
    if "dfa" in str_x:
        str_x = "dfa"
    if "dfb" in str_x:
        str_x = "dfb"
    if "dfa" in str_y:
        str_y = "dfa"
    if "dfb" in str_y:
        str_y = "dfb"
    
    if str_x == str_y:
        return "{}*{}/2".format(str_x,str_y)
    if str_x < str_y:
        return "{}*{}".format(str_x,str_y)
    else:
        return "{}*{}".format(str_y,str_x)




def test_v_funky_a_to_b_type_4(v,from_a,to_b,swap_letters_ab = False, use_df=False):
    if not contains_a_nonedge_b(v,from_a, to_b):
        return None

    for [x,y] in [[0,1], [1,2], [2,3]]:
       if is_funky_type_1(v[x],v[y]):
           return None
       if is_funky_type_2(v[x],v[y]):
           return None
           
    #print "still going ", v
    
    [a,b] = find_ab_nonedge(v, from_a, to_b)
            
    # path is  a--x--b--y
    if a == 0 and b == 2:
        [x,y] = [1,3] # here [a,b] = [0,2]
        if not is_non_edge(v[x],v[y]):
            return "f"
        str_x = "x[{}]".format(v[x])
        str_y = "x[{}]".format(v[y])
        if use_df:
            if v[x] == v[a]:
               str_x = "daout" 
            if v[y] == v[a]:
               str_y = "danon"
            if v[x] == v[b]:
               str_x = "dbin" 
            if v[y] == v[b]:
               str_y = "dbout"
        if v[a] == v[x]:
            str_x = "dfa"
        if v[b] == v[x]:
            str_x = "dfb"
        if v[b] == v[y]:
            str_y = "dfb"
        if not is_edge(v[a],v[x]):
            str_x = "dfa[{}]".format(v[x])
        if not is_non_edge(v[a],v[y]):
            str_y = "dfa[{}]".format(v[y])
        if not is_edge(v[x],v[b]):
            str_x = "dfb[{}]".format(v[x])
        if not is_edge(v[b],v[y]):
            str_y = "dfb[{}]".format(v[y])
            
    # path is  a--x--y--b      
    if a == 0 and b == 3:
        [x,y] = [1,2] # here [a,b] = [1,2]
        if not is_edge(v[x],v[y]):
            #print " x-y is funky"
            return "f"
            
        str_x = "x[{}]".format(v[x])
        str_y = "x[{}]".format(v[y])
        if use_df:
            if v[x] == v[a]:
               str_x = "daout" 
            if v[y] == v[a]:
               str_y = "danon"
            if v[x] == v[b]:
               str_x = "dbnon" 
            if v[y] == v[b]:
               str_y = "dbin"
        if v[a] == v[x]:
            str_x = "dfa"
        if v[b] == v[y]:
            str_y = "dfb"               
        if not is_edge(v[a],v[x]):
            str_x = "dfa[{}]".format(v[x])
        if not is_non_edge(v[a],v[y]):
            str_y = "dfa[{}]".format(v[y])
        if not is_non_edge(v[x],v[b]):
            str_x = "dfb[{}]".format(v[x])
        if not is_edge(v[y],v[b]):
            str_y = "dfb[{}]".format(v[y])

    # path is  x--a--y--b      
    if a == 1 and b == 3:
        [x,y] = [0,2] # 
        if not is_non_edge(v[x],v[y]):
            #print " x-y is funky"
            return "f"
        str_x = "x[{}]".format(v[x])
        str_y = "x[{}]".format(v[y])
        if use_df:
            if v[x] == v[a]:
               str_x = "dain" 
            if v[y] == v[a]:
               str_y = "daout"
            if v[x] == v[b]:
               str_x = "dbnon" 
            if v[y] == v[b]:
               str_y = "dbin" 
        if v[a] == v[x]:
            str_x = "dfa"
        if v[a] == v[y]:
            str_y = "dfa"
        if v[b] == v[y]:
            str_y = "dfb"              
        if not is_edge(v[x],v[a]):
            str_x = "dfa[{}]".format(v[x])
        if not is_edge(v[a],v[y]):
            str_y = "dfa[{}]".format(v[y])
        if not is_non_edge(v[x],v[b]):
            str_x = "dfb[{}]".format(v[x])
        if not is_edge(v[y],v[b]):
            str_y = "dfb[{}]".format(v[y])
    #print "{} {}*{}".format(v,str_x,str_y)     
    #print "{}*{}".format(str_x,str_y)
    
    if "dfa" in str_x:
        str_x = "dfa"
    if "dfb" in str_x:
        str_x = "dfb"
    if "dfa" in str_y:
        str_y = "dfa"
    if "dfb" in str_y:
        str_y = "dfb"
        
    return_str=""    
    if str_x == str_y:
        return_str="{}*{}/2".format(str_x,str_y)
    elif str_x < str_y:
        return_str="{}*{}".format(str_x,str_y)
    else:
        return_str="{}*{}".format(str_y,str_x)

    if swap_letters_ab:
        return_str = return_str.replace('a','W').replace('b','a').replace('W','b')
        
    return return_str

def is_funky(v,a,b):
    if v[a] == 0 or v[b] == 0:
        return False
    [a,b] = sorted([a,b])
    if a+1 == b:
        if not is_edge(v[a],v[b]) or v[a] == v[b]:
            return True
    else:
        if not is_non_edge(v[a],v[b]):
            return True
    return False
    
def test_funky_all_in_one(v,x):
    if v[x] != 1:
        return None
    for [a,b] in [[0,1], [1,2], [2,3]]:
        if ((not is_edge(v[a],v[b])) or (v[a] == v[b] and v[a] != 0)) and x != a and x != b:
            return None
    for [a,b] in [[0,2], [0,3], [1,3]]:
        if (not is_non_edge(v[a],v[b])) and x != a and x != b:
            return None
    
    if x < 3 and v[x] == v[x+1]:
        return None

    if x > 0 and v[x] == v[x-1]:
        return None

    
    v_idx = [0,1,2,3]
    del v_idx[x]
    #print x,v, v_idx
    [a,b,c] = v_idx

    # skip x[0]
    if v[a] == 0 or v[b] == 0 or v[c] == 0:
        return None

    str_a = "x[{}]".format(v[a])
    str_b = "x[{}]".format(v[b])
    str_c = "x[{}]".format(v[c])
    
    if is_funky(v,a,x):
       str_a = "df[{}]".format(v[a]) 
    if is_funky(v,b,x):
       str_b = "df[{}]".format(v[b]) 
    if is_funky(v,c,x):
       str_c = "df[{}]".format(v[c]) 
            
    all_str=sorted([str_a,str_b,str_c])
    return "{}*{}*{}".format(all_str[0], all_str[1], all_str[2])

TestType = 5

all_constraints = set()
for a in range(6):
    for b in range(6):
        for c in range(6):
            for d in range(6):
                v = [a,b,c,d]
                
                if TestType == 1:
                    plot_special=find_ab(v,2,1)
                    entry= test_v_funky_a_to_b(v,2,1, use_df=False, skip_type1=False, skip_type2=False)
                if TestType == 2:
                    plot_special=find_ab(v,3,1)
                    entry= test_v_funky_a_to_b(v,3,1, use_df=False, skip_type1=True, skip_type2=False)
                if TestType == 3:
                    plot_special=find_ab(v,1,3)
                    entry= test_v_funky_a_to_b(v,1,3, use_df=False, skip_type1=True, skip_type2=True, skip_type4= False)
                if TestType == 4:
                   plot_special=find_ab_nonedge(v,1,2)
                   entry= test_v_funky_a_to_b_type_4(v,1,2, swap_letters_ab=False)
                
                if TestType == 5:
                    for x in range(4):
                       entry=test_funky_all_in_one(v,x) 
                       if not entry == None:
                            plot_P4(v,entry,[x])
                            all_constraints.add(entry)
                    entry=None

                    
                if not entry == None:
                    if not entry == "f":
                        plot_P4(v,entry, plot_special)
                    all_constraints.add(entry)
                    
                if TestType == 4:
                    entry= test_v_funky_a_to_b_type_4(v,2,1, swap_letters_ab=True)
                    if not entry == None:
                        if not entry == "f":
                            plot_P4(v,entry, find_ab_nonedge(v,2,1))
                        all_constraints.add(entry)



                  
out_str=""
for entry in sorted(list(all_constraints)):
    out_str += " + "
    out_str += entry


print "%  ",out_str

